.\"	$NetBSD: kpause.9,v 1.4 2008/04/30 13:10:58 martin Exp $
.\"
.\" Copyright (c) 2006, 2007 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Andrew Doran.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\" ------------------------------------------------------------
.Dd January 2, 2008
.Dt KPAUSE 9
.Os
.\" ------------------------------------------------------------
.Sh NAME
.Nm kpause
.Nd make the calling LWP sleep
.\" ------------------------------------------------------------
.Sh SYNOPSIS
.In sys/proc.h
.\" - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.Ft int
.Fn kpause \
"const char *wmesg" "bool intr" "int timeo" "kmutex_t *mtx"
.\" ------------------------------------------------------------
.Sh DESCRIPTION
.Fn kpause
makes the calling LWP sleep.
It's similar to
.Xr cv_timedwait_sig 9
without the corresponding
.Xr cv_signal 9 .
.Pp
.Fn kpause
can wake up spontaneously.
Callers should prepare to handle it.
.Pp
.Bl -tag -width wmesg
.It Fa wmesg
Specifies a string of no more than 8 characters that describes
the resource or condition associated with the call of
.Fn kpause .
The kernel does not use this argument directly but makes it available for
utilities such as
.Xr ps 1
to display.
.It Fa intr
If true, sleep interruptably.
If the LWP receives a signal, or is interrupted by another condition such
as its containing process exiting, the wait is ended early and an error
code returned.
.It Fa timeo
Specify a timeout.
It is an architecture and system dependent value related to the number of
clock interrupts per second.
See
.Xr hz 9
for details.
The
.Xr mstohz 9
macro can be used to convert a timeout expressed in milliseconds to
one suitable for
.Fn kpause .
.Pp
Zero means no timeout.
.It Fa mtx
Convenience and symmetry with other synchronization operations.
If not
.Dv NULL ,
.Fa mtx
will be released once the LWP has prepared to sleep, and will be reacquired
before
.Fn kpause
returns.
.El
.\" ------------------------------------------------------------
.Sh RETURN VALUES
.Fn kpause
returns 0 when waking up spontaneously.
Otherwise,
It returns an error number.
.\" ------------------------------------------------------------
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er EWOULDBLOCK
The timeout expired.
.It Bq Er ERESTART
.Fn kpause
returned as a result of a signal with
.Dv SA_RESTART
property.
.It Bq Er EINTR
.Fn kpause
returned due to other reasons.
Typically as a result of a signal without
.Dv SA_RESTART
property.
.El
.\" ------------------------------------------------------------
.Sh SEE ALSO
.Xr sigaction 2 ,
.Xr errno 9 ,
.Xr condvar 9 ,
.Xr mstohz 9 ,
.Xr hz 9
